#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include <avr/pgmspace.h>

#define END  (0xff)

#include "len.h"
#include "note.h"

//#define LSPEED 1

#ifdef LSPEED
  #define BASE (4096)
#else
  #define BASE (4096*2)
#endif



// 8 WaveTable

signed char table[4][8] = {
	{0,90,127,90,0,-90,-127,-90},
	{0,	45,	63,	45,	0,	-45,	-64,	-45},
	{0, 22,	31,	22,	0,	-23,	-32,	-23},
	{0,	11,	15,	11,	0,	-12,	-16,	-12}
};

/*
signed char table[] = {	0,90,127,90,0,-90,-127,-90};
*/		
// ֹ->ȿΥơ֥
const PROGMEM unsigned int tonetable[] = {
	0, // 
	131,139,147,156,165,175,185,196,208,220,233,247, // O3
	262,277,294,311,330,349,370,392,415,440,466,494, // O4          
	523,554,587,622,659,698,740,784,831,880,932,988, // O5
	1047,1109,1175,1245,1319,1397,1480,1568,1661,1760,1865,1976, // O6
	2093,2217,2349,2489,2637,2794,2960,3136,3322,3520,3729,3951  // O7
};

// Ĺ̾
signed char lennum[] = {2, 4, 8, 16};

volatile char vol1= 0;
volatile char vol2= 0;
volatile char vol3= 0;

#define basevol1 0
#define basevol2 1
#define basevol3 2

// ϼȿ
volatile unsigned int freq1=0;
volatile unsigned int freq2=0;
volatile unsigned int freq3=0;
volatile unsigned int tics=0;

// 1 Сե
#pragma GCC optimize ("O3")
ISR(SIG_OVERFLOW1) {
	volatile static char pt1 = 0;
	volatile static char pt2 = 0;
	volatile static char pt3 = 0;
	volatile static int cnt1 = 0;
	volatile static int cnt2 = 0;
	volatile static int cnt3 = 0;
	//	volatile int value;
	register int value;	
	tics++;
	
	cnt1 -= freq1;
	if (cnt1<0) {	cnt1 = cnt1 + BASE;	pt1++;	pt1 &= 0b111;	}

	cnt2 -= freq2;
	if (cnt2<0) {	cnt2 = cnt2 + BASE;	pt2++;	pt2 &= 0b111;	}

	cnt3 -= freq3;
	if (cnt3<0) {	cnt3 = cnt3 + BASE;	pt3++;	pt3 &= 0b111;	}
	
	value = 0;

	if (freq1) { value += (table[(int)vol1][(int)pt1]); }
	if (freq2) { value += (table[(int)vol2][(int)pt2]); }
	if (freq3) { value += (table[(int)vol3][(int)pt3]); }
	value = value>>1;	
	
	//	value = table[pt1]/2+table[pt2]/4+table[pt3]/4;
	OCR1A = value+128;
	return;
}
#pragma GCC optimize ("Os")



// sound main
int main(void) {
	cli(); // ߶ػ

	// ޽(1 PWM)
	GTCCR |= _BV(TSM);     // 곫
	PLLCSR |= _BV(PCKE);   // 1 Υ١å PLL 64MHz 
	TCCR1  |= _BV(PWM1A);  // 1B  PWM ưؼ
	TCCR1  |= _BV(COM1A0); // OC1A(PB0,pinx)  **ȿž** Ϥؼ, ǥ塼ƥ OCR1A 
#ifdef LSPEED
	TCCR1  |= _BV(CS12);   // 1 8ʬ
#else
	TCCR1  |= _BV(CS11) | _BV(CS10);   // 1 4ʬ
#endif
	TIMSK  |= _BV(TOIE1);  // 1Сեߵ
	OCR1C = 255;           // Сեߤ OCR1C Ȥ(PWMTCCR1:CTC1ˤ餺)
	GTCCR &= ~_BV(TSM);    // 꽪λ

	// GPIO
	DDRB  |= _BV(PB0); // PB0(PWM OC1A,pinx)ϥԥ˻ؼ
	sei(); // ߵ(߳ϰ֤)
	
#define K 50
#define N 145
#ifdef LSPEED
  #define C (62500/2)
#else
	  #define C (62500/1)
#endif
	
#define B (C*60/N/K*4)

	//		freq1 = 880;
	//		while(1);
	while(1) {
		unsigned char tone; // ֹ
		unsigned char len;  // Ĺ

		// Ĺ
		static int cnt1=0;
		static int cnt2=0;
		static int cnt3=0;
		// ̾
		static int onpu1=0;
		static int onpu2=0;
		static int onpu3=0;
		// ݥ
		static int gp1=0;
		static int gp2=0;
		static int gp3=0;
		//Ρȥեե
		//static int stop1=0;
		//static int stop2=0;
		//static int stop3=0;

		// ٥
		// Ch.1
		if (cnt1<B/8*1)      vol1=basevol1+3;
		else if (cnt1<B/8*2) vol1=basevol1+2;
		else if (cnt1<B/8*4) vol1=basevol1+1;
		// Ch.2
		if (cnt2<B/8*4)      vol2=basevol2+1;
		// Ch.3
		if (cnt3<B/8*4)      vol3=basevol3+1;
		
		//  K 1ᥤ롼פ¹
		if (tics>K) {
			tics=0;

			/*
			// Ρȥ
			stop1--;
			stop2--;
			stop3--;
			if (freq1 && stop1==0) freq1=0;
			if (freq2 && stop2==0) freq2=0;
			if (freq3 && stop3==0) freq3=0;
			*/
			
			// Ĺ󥿤θ
			if (cnt1>0) {
				// ǥ
				cnt1 -= onpu1;
			} else {
				cnt1+=B;
				// ɤ߽Ф
				if (pgm_read_byte(gakufu1+gp1)==0xff) {
					// ʹ
					freq1=0;
				} else {
					tone  = pgm_read_byte(gakufu1+gp1) & 0b00111111;
					len   = lennum[pgm_read_byte(gakufu1+gp1) >> 6];
					onpu1 = len;
					freq1 = pgm_read_word(tonetable+tone);
					gp1++;
					//stop1=B*7/8/len;
					vol1 = basevol1;
				}
			} //if (cnt1>onpu1) {

			// Ĺ󥿤θ
			if (cnt2>0) {
				// ǥ
				cnt2 -= onpu2;
			} else {
				cnt2+=B;
				// ɤ߽Ф
				if (pgm_read_byte(gakufu2+gp2)==0xff) {
					// ʹ
					freq2=0;
				} else {
					tone  = pgm_read_byte(gakufu2+gp2) & 0b00111111;
					len   = lennum[pgm_read_byte(gakufu2+gp2) >> 6];
					onpu2 = len;
					freq2 = pgm_read_word(tonetable+tone);
					gp2++;
					//stop2=B*7/8/len;
					vol2 = basevol2;
				}
			} //if (cnt1>onpu1) {

			// Ĺ󥿤θ
			if (cnt3>0) {
				// ǥ
				cnt3 -= onpu3;
			} else {
					cnt3+=B;
				// ɤ߽Ф
				if (pgm_read_byte(gakufu3+gp3)==0xff) {
					// ʹ
					freq3=0;
				} else {
					tone  = pgm_read_byte(gakufu3+gp3) & 0b00111111;
					len   = lennum[pgm_read_byte(gakufu3+gp3) >> 6];
					onpu3 = len;
					freq3 = pgm_read_word(tonetable+tone);
					gp3++;
					//stop3=B*7/8/len;					
					vol3 = basevol3;
				}
			} //if (cnt1>onpu1) {

		}	// if (tics>K) 
	}
	
	return 0;
}

